#!/usr/bin/perl

# make index title 

if ($ARGV[0] eq "") { usage(); };

$ifname = $ARGV[0];

if (!open(IFILE, $ifname)) {
        print "Cannot open file '",$ifname2,"'.\n";
        exit;
};

while (defined($line = <IFILE>)) {
  chomp $line;

  if( $line =~ /^(\d) +([\w\.]+) +(\w+) +(\w+) +(\w+) +/ ) { 
    $lvl=$1;   # Section level
    $sstr=$2;  # Section string
    $hstr=$3;  # html name
    $lstr=$4;  # link name
    $pmark=$5; # page break mark
    $msg=$';   # section title

    # printf "#%s#%s#%s#%s#%s#%s#\n", $lvl,$sstr,$hstr,$lstr,$pmark,$msg;

    # make indentation and spacing description (as table).
    $ind="";
    if($lvl eq 1) {
      $sstr=sprintf "%s ",$sstr;
      $msg=sprintf "<b>%s</b>",$msg;  # as BOLD
      $ind.="\n<img border=\"0\" src=\"space.gif\" width=\"2\" height=\"5\"><br>\n";
      $ind.="<img border=\"0\" src=\"space.gif\" width=\"2\" height=\"1\">";
    } elsif($lvl eq 2) {
      $sstr=sprintf "%s ",$sstr;
      $ind.="<img border=\"0\" src=\"space.gif\" width=\"12\" height=\"5\">";
    } elsif($lvl eq 3) {
      $sstr="";
      $ind.="<img border=\"0\" src=\"space.gif\" width=\"22\" height=\"5\">";
    } else {
      # nothing to do.
    };

    # write a mark.
    # printf "<img src=\"mark1.gif\">&nbsp;";

    if($lvl ge 4) { # over level 4, omit the output.
      # nothing to do.
    } else {
      # write content 
      if($lstr eq "_") { # link to page top.
        printf "<a name=\"%s\"></a>",$hstr; # name tag.
        printf "<a target=\"body\" href=\"_%s.html\" style=\"text-decoration:none\">%s%s%s</a><br>\n",$hstr,$ind,$sstr,$msg;
      } else { # link to inside the page.
        printf "<a name=\"%s\"></a>",$lstr; # name tag.
        printf "<a target=\"body\" href=\"_%s.html#%s\" style=\"text-decoration:none\">%s%s%s</a><br>\n",$hstr,$lstr,$ind,$sstr,$msg;
      };
    };
  };

}

close(IFILE);

exit;

sub usage() {
        print "usage: mkdocs_c.pl index.dat\n";
        print "  read index database to make content list in HTML. \n";
        exit;
}

