#!/usr/bin/perl

# Section list database, format is;
# level label html_file link_name    p title_string ))
# 1     1.    top       _            p Guidemaker 
# 2     1.1   install   _            p 󥹥ȡ
# 3     1.1.1 install   requirements _ ƥ׷
# 2     1.2   basic     _            p Ū
# 3     1.2.1 basic     howitworks   _ mkdocs.sh ư
# 1     2.    struct    _            p Τι¤
# 2     2.1   struct    sample       _ Ǥñʥץ
# .....
# 1     8.    credit    _            p ռ
#
# 
#


if ($ARGV[0] eq "") { usage(); };

$ifname = $ARGV[0];

if (!open(IFILE, $ifname)) {
        print "Cannot open file '",$ifname2,"'.\n";
        exit;
};

$sno1=0; # section number level 1.
$sno2=0; # section number level 2.
$sno3=0; # section number level 3.
$sno4=0; # section number level 4.

$hstr=""; 

while (defined($line = <IFILE>)) {
  chomp $line;

  if($line =~ /^Sec(\d): (\w+) +/ ) {  # check Sec?: tag.
    $lvl=$1; # Section level
    $lnk=$2; # link target
    $msg=$'; # section title

    if($hstr eq "") { # processing the first line of input.
      $hstr=$lnk;
    };

    if($lvl eq 1) { # Section level 1. 
      $sno1+=1; $sno2=0; $sno3=0; $sno4=0;
      $sstr=sprintf "%d.",$sno1;
    } elsif($lvl eq 2) { # Section level 2.
      $sno2+=1; $sno3=0; $sno4=0;
      $sstr=sprintf "%d.%d",$sno1,$sno2;
    } elsif($lvl eq 3) { # Section level 3.
      $sno3+=1; $sno4=0;
      $sstr=sprintf "%s.%s.%s",$sno1,$sno2,$sno3;
    } else { # Section level should be 4.
      $sno4+=1;
      $sstr=sprintf "%s.%s.%s.%s",$sno1,$sno2,$sno3,$sno4;
    };

    # write a header with or without link.
    if($lnk eq "_") { # it has no link. just show it as subtitle.
      $lstr="_";
      $pmark="_";
    } elsif($lnk =~ /^_(\w+)$/ ) {
      # with "_" (Non-page-break mark)
      $lstr=$1; 
      $pmark="_";
    } else {
      # with page break
      $hstr=$lnk;
      $lstr="_";
      $pmark="p";
    };

    printf "%d %-8s %-14s %-14s %s %s\n",$lvl,$sstr,$hstr,$lstr,$pmark,$msg;


  };

}

close(IFILE);

exit;

sub usage() {
        print "usage: mkdocs_i.pl body.txt\n";
        print " will read body.txt file to output as index database. \n";
        exit;
}

